#pragma once

#include <STRING>
#include <FSTREAM>
#include <ios>

using std::string;
using std::fstream;
using std::ios;

/*-------------------------------------
,     :

; 
Name1 = "11111" 

  ; 
  Name2=123.44
Name3= 111
Name4

	Name5 ="1111"
---------------------------------------*/

#define ERR_OPENFILE				1
#define ERR_TYPE					2
#define ERR_NOTCREATE				3
#define ERR_ENDOFFILE				4

//   
enum StringType
{
	SD_BASE		= -2,
	ST_ERROR	= -1,												//    
	ST_NAMEONLY = 0,												//  ,   
	ST_STRING	= 1,													//  - 
	ST_INT		= 2,														//  -  
	ST_FLOAT	= 3													//  -  
};

enum OpenType									//   
{
	OT_NONE = 0,
	OT_READ,
	OT_WRITE
};


//     
class StringData
{
public:
	string Name;											//  
	StringType Type;										//  

	//         Type
	string strVal;
	int intVal;
	double fVal;
	virtual StringType GetType() { return SD_BASE; };		//     

	StringData()
	{
		Type = ST_ERROR;
		intVal = 0;
		fVal = 0.0;
	}

	StringData (const StringData& d)
	{
		Name = d.Name;
		Type = d.Type;
		strVal = d.strVal;
		intVal = d.intVal;
		fVal = d.fVal;
	}

	StringData& operator= (const StringData& d)
	{
		if (this != &d)
		{
			Name = d.Name;
			Type = d.Type;
			strVal = d.strVal;
			intVal = d.intVal;
			fVal = d.fVal;
		}
		return *this;
	}
};


class CTextParser
{
public:

protected:

	OpenType m_Created;									//     Create
	fstream m_fp;									//   
	void TrimString(string *str);					//     
	
	//      
	bool SeparateString(string strIn, string *strName, string *strVal);

	void GetType (string str, StringData *info);
	bool IsFloat(string str);
	bool IsInt(string str);

	//        
	//   true,   
	virtual bool CustomType(string str, StringData *info) { return false; };

	unsigned int m_CurLine;							//  

	//  
	int m_ErrNumber;								//  
	string m_strError;								//     

	bool WriteBuf (string str);
public:
	CTextParser(void);
	virtual ~CTextParser(void);

	OpenType Create(const char *fname, bool Write, bool Overwrite = false);	//    
	void Destroy();													//    (  )
	bool GetNextValue(StringData *info);							//    (  )

	//     
	bool Write (string name, string val);
	bool Write (string name, int val);
	bool Write (string name, float val);
	bool Write (string name, double val);
	bool Write (StringData *info);
	bool WriteComment(string str);

	//   
	void GetTextError (string *str);
	int GetCurLine();
	int GetError () { return m_ErrNumber; };
};
